class Bidict(dict):
    def __init__(self, *args, **kwargs):
        super(Bidict, self).__init__(*args, **kwargs)

        self.inverse = {}
        for key, value in self.iteritems():
            self.inverse.setdefault(value, []).append(key)

    def __setitem__(self, key, value):
        super(Bidict, self).__setitem__(key, value)

        self.inverse.setdefault(value, []).append(key)

    def __delitem__(self, key):
        super(Bidict, self).__delitem__(key)

        self.inverse.setdefault(self[key], []).remove(key)
        if self[key] in self.inverse and not self.inverse[self[key]]:
            del self.inverse[self[key]]
