class ColumnPrinter(object):
    def __init__(self, sep=4, prefix='', incremental=False):
        self.prefix = prefix
        self.sep = sep
        self.incremental = incremental

        self.rows = []

    def append(self, row, func=lambda x: x):
        self.rows.append([str(func(r)) for r in row])

        if self.incremental:
            # TODO: fix for changing column size
            self.output()
            self.rows = []

    def output(self):
        len_range = xrange(len(self.rows[0]))
        width = [
            max(len(row[i]) for row in self.rows) + self.sep
            for i in len_range
        ]

        for row in self.rows:
            # TODO: align decimals, etc
            print self.prefix + (
                ''.join(
                    ''.join(row[i].ljust(width[i]))
                    for i in len_range
                )
            )
